float Material_U;

float4x4 MatrixW;
float4x4 MatrixWVP;

float4 MaterialAmbientColor;
float4 MaterialDiffuseColor;

float4 LightDiffuseColor;
float4 LightAmbientColor;
float3 LightDirection;

float SinWave;

int Counter;

texture BlinkTexture;

sampler BlinkTextureSampler = 
sampler_state{
	Texture = < BlinkTexture >;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
};

texture LineTexture;

sampler LineTextureSampler = 
sampler_state{
	Texture = < LineTexture >;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
};

texture DotTexture;

sampler DotTextureSampler = 
sampler_state{
	Texture = < DotTexture >;
	MipFilter = POINT;
	MinFilter = POINT;
	MagFilter = POINT;
};

// _VF[_
struct VS_OUTPUT{
	float4 Pos		: POSITION;
	float4 Col		: COLOR0;
	float2 TexUV	: TEXCOORD0;
};

VS_OUTPUT VS(
	float4 Pos			: POSITION,
	float3 Normal		: NORMAL,
	float2 TexCoord0	: TEXCOORD0 )
{
	VS_OUTPUT Out = (VS_OUTPUT)0;
	Out.Pos = mul( Pos, MatrixWVP );

	// Œ蒸_̒_FvZ
//	float3 NormalW = normalize( mul( Normal, (float3x3)MatrixW ) );
//	Out.Col = MaterialDiffuseColor * LightDiffuseColor * max( dot( -LightDirection, NormalW ), 0 ) +// MaterialAmbientColor * LightAmbientColor;

	Out.Col = float4( 1.0f, 1.0f, 1.0f, 1.0f );
	Out.TexUV = TexCoord0;

	return Out;
}

// sNZVF[_
float4 PS_Blink( VS_OUTPUT In ) : COLOR0
{
	float4 TexCol = tex2D( BlinkTextureSampler, In.TexUV );
//	float4 Col = TexCol * In.Col;
	float4 Col = TexCol;

	float Luminance = TexCol.r + TexCol.g + TexCol.b;
	/*if( Luminance > 0.3f )*/{
//		TexCol /= Luminance;
/*
		if( TexCol.r > 0.99f && TexCol.g < 0.01f && TexCol.b < 0.01f ){
			 Col.r = SinWave;
			 Col.g = SinWave * 0.2f;
			 Col.b = SinWave * 0.2f;
		}
*/
		 Col.r = TexCol.r * SinWave;
		 Col.g = TexCol.r * SinWave * 0.2f;
		 Col.b = TexCol.r * SinWave * 0.2f;

	}

	return Col;
}

/*
// sNZVF[_
float4 PS_Line( VS_OUTPUT In ) : COLOR0
{
	float4 TexCol = tex2D( LineTextureSampler, In.TexUV );
	float4 Col = TexCol * In.Col;

	float fCounter = float( Counter % 100 ) / 100 * 0.6 + 0.2;
	if( TexCol.b > fCounter - 0.19 && TexCol.b < fCounter + 0.19 && TexCol.r < 0.001 ){
		Col.r = 0.2f;
		Col.g = 0.2f;
		Col.b = 1.0f;
	}
	else{
		Col.r = 0.0f;
		Col.g = 0.0f;
		Col.b = 0.0f;
	}

	return Col;
}
*/

// sNZVF[_
float4 PS_Line( VS_OUTPUT In ) : COLOR0
{
	float4 TexCol = tex2D( LineTextureSampler, In.TexUV );
	float4 Col = TexCol * In.Col;
	
	float fCounter = float( Counter % 120 ) / 120;
	float Begin = fCounter - 0.2f;
	float End   = fCounter + 0.2f;

	/*if( TexCol.r < 0.001 )*/{
		if( Begin < 0.0f ){
			if( ( TexCol.b > 1.0f + Begin ) || ( TexCol.b < End ) ){
				Col.r = 0.2f;
				Col.g = 0.2f;
				Col.b = 1.0f;
			}
			else{
				Col.r = 0.04f;
				Col.g = 0.04f;
				Col.b = 0.2f;
			}
		}
		else if( End > 1.0f ){
			if( ( TexCol.b > Begin ) || ( TexCol.b < End  - 1.0f ) ){
				Col.r = 0.2f;
				Col.g = 0.2f;
				Col.b = 1.0f;
			}
			else{
				Col.r = 0.04f;
				Col.g = 0.04f;
				Col.b = 0.2f;
			}
		}
		else{
			if( TexCol.b > Begin && TexCol.b < End ){
				Col.r = 0.2f;
				Col.g = 0.2f;
				Col.b = 1.0f;
			}
			else{
				Col.r = 0.04f;
				Col.g = 0.04f;
				Col.b = 0.2f;
			}
		}
	}/*
	else{
		Col.r = 0.04f;
		Col.g = 0.04f;
		Col.b = 0.2f;
	}*/

	return Col;
}

/*
// sNZVF[_
float4 PS_Dot( VS_OUTPUT In ) : COLOR0
{
	float4 TexCol = tex2D( DotTextureSampler, In.TexUV );
	float4 Col = TexCol * In.Col;
	
	float fCounter = float( Counter % 60 ) / 60 * 0.8 + 0.1;
	if( TexCol.r > fCounter - 0.05 && TexCol.r < fCounter + 0.05 ){
		Col.r = 0.2f;
		Col.g = 0.2f;
		Col.b = 1.0f;
	}
	else{
		Col.r = 0.04f;
		Col.g = 0.04f;
		Col.b = 0.2f;
	}
	
	return Col;
}
*/

// sNZVF[_
float4 PS_Dot( VS_OUTPUT In ) : COLOR0
{
	float4 TexCol = tex2D( DotTextureSampler, In.TexUV );
	float4 Col = TexCol * In.Col;
	
	float fCounter = float( Counter % 120 ) / 120;
	float Begin = fCounter - 0.05f;
	float End   = fCounter + 0.05f;
/*	
	if( Begin < 0.0f ){
		if( ( TexCol.r > 1.0f + Begin ) || ( TexCol.r < End ) ){
			Col.r = 0.2f;
			Col.g = 0.2f;
			Col.b = 1.0f;
		}
		else{
			Col.r = 0.04f;
			Col.g = 0.04f;
			Col.b = 0.2f;
		}
	}
	else if( End > 1.0f ){
		if( ( TexCol.r > Begin ) || ( TexCol.r < End  - 1.0f ) ){
			Col.r = 0.2f;
			Col.g = 0.2f;
			Col.b = 1.0f;
		}
		else{
			Col.r = 0.04f;
			Col.g = 0.04f;
			Col.b = 0.2f;
		}
	}
	else*/{
		if( TexCol.r > Begin && TexCol.r < End ){
			Col.r = 0.2f;
			Col.g = 0.2f;
			Col.b = 1.0f;
		}
		else{
			Col.r = 0.04f;
			Col.g = 0.04f;
			Col.b = 0.2f;
		}
	}

	return Col;
}

// eNjbN
technique BlinkShader{
	pass P0{
		VertexShader = compile vs_2_0 VS();
		PixelShader  = compile ps_2_0 PS_Blink();
	}
}

technique LineShader{
	pass P0{
		VertexShader = compile vs_2_0 VS();
		PixelShader  = compile ps_2_0 PS_Line();
	}
}

technique DotShader{
	pass P0{
		VertexShader = compile vs_2_0 VS();
		PixelShader  = compile ps_2_0 PS_Dot();
	}
}
